#include <windows.h>
#include <stdio.h>
#include "690.h"

// private type declaration
typedef struct FooDataX
{
	FooData foo;

	// private part never exposed
	char * extra;
} FooDataX;


// private interface implemetation
static
BOOL DetectFooDataXType(FooData * data)
{
	FooDataX * foox = (FooDataX *)data;

	if (data->size == sizeof(FooDataX))
	{
		// accessing private data
		printf("FooDataX detected. Extra = %s\n", foox->extra);
		return TRUE;
	}

	return FALSE;
}

// public interface implementation

FooData * createFooData()
{
	int size = sizeof(FooData);
	FooData * data = malloc(size);
	memset(data, 0, size);
	data->size = size;
	return data;
}

FooData * createFooDataX()
{
	int size = sizeof(FooDataX);
	FooDataX * data = malloc(size);
	memset(data, 0, size);
	data->foo.size = size;
	data->extra = "Payload";
	return &data->foo;
}

void DetectFooDataType(FooData * data)
{
	if (data->size == sizeof(FooData))
	{
		printf("FooData detected.\n");
		return;
	}

	// calling private interface

	if (!DetectFooDataXType(data))
		printf("Unknown FooData subtype.\n");
}
